# Integer overflow in parse_report (whoopsie CVE-2019-11476)

[CVE-2019-11476](https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-11476)
is a local denial of service vulnerability in
[whoopsie](https://launchpad.net/ubuntu/+source/whoopsie).
An integer overflow when reading large crash dumps (> 4GB) leads to a heap buffer overflow.
I do not believe it is possible to exploit this heap buffer overflow to achieve code execution,
so I have classified this bug as a denial of service.
The full bug report is public on `bugs.launchpad.net`:
[bug 1830863](https://bugs.launchpad.net/ubuntu/+source/whoopsie/+bug/1830863).

## Instructions

Note: these reproduction steps will only work with a vulnerable version of whoopsie.
See [CVE-2019-11476](https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-11476)
for a list of vulnerable versions.

Build the PoC as follows:

```bash
make
```

And run it like this:

```bash
./killwhoopsie1
```

The PoC works by creating a file named `/var/crash/killwhoopsie.crash`,
just over 4GB in size. It then creates a file named
`/var/crash/killwhoopsie.upload`, which prompts whoopsie to start
processing the .crash file. Be aware that whoopsie will keep restarting
and crash repeatedly until you remove the files from `/var/crash`:

```bash
rm /var/crash/killwhoopsie.*
```
